// Generated by gencpp from file ld_msgs/ld_imugps_can.msg
// DO NOT EDIT!


#ifndef LD_MSGS_MESSAGE_LD_IMUGPS_CAN_H
#define LD_MSGS_MESSAGE_LD_IMUGPS_CAN_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <geometry_msgs/Quaternion.h>
#include <geometry_msgs/Vector3.h>
#include <geometry_msgs/Vector3.h>
#include <geometry_msgs/Vector3.h>
#include <geometry_msgs/Vector3.h>

namespace ld_msgs
{
template <class ContainerAllocator>
struct ld_imugps_can_
{
  typedef ld_imugps_can_<ContainerAllocator> Type;

  ld_imugps_can_()
    : header()
    , can_ts()
    , gps_ts()
    , imu_ts()
    , v_x_CAN(0.0)
    , v_x_CAN_covariance(0.0)
    , yawrate(0.0)
    , yawrate_covariance(0.0)
    , acceleration_x(0.0)
    , acceleration_x_covariance(0.0)
    , acceleration_y(0.0)
    , acceleration_y_covariance(0.0)
    , orientation()
    , orientation_covariance()
    , angular_velocity_imugps()
    , angular_velocity_imugps_covariance()
    , linear_acceleration_imugps()
    , linear_acceleration_imugps_covariance()
    , roll_pitch_yaw_imugps()
    , roll_pitch_yaw_imugps_covariance()
    , linear_velocity_imugps()
    , linear_velocity_imugps_covariance()
    , v_x_imugps(0.0)
    , v_x_imugps_covariance(0.0)
    , altitude(0.0)
    , longitude(0.0)
    , latitude(0.0)
    , position_covariance()  {
      orientation_covariance.assign(0.0);

      angular_velocity_imugps_covariance.assign(0.0);

      linear_acceleration_imugps_covariance.assign(0.0);

      roll_pitch_yaw_imugps_covariance.assign(0.0);

      linear_velocity_imugps_covariance.assign(0.0);

      position_covariance.assign(0.0);
  }
  ld_imugps_can_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , can_ts()
    , gps_ts()
    , imu_ts()
    , v_x_CAN(0.0)
    , v_x_CAN_covariance(0.0)
    , yawrate(0.0)
    , yawrate_covariance(0.0)
    , acceleration_x(0.0)
    , acceleration_x_covariance(0.0)
    , acceleration_y(0.0)
    , acceleration_y_covariance(0.0)
    , orientation(_alloc)
    , orientation_covariance()
    , angular_velocity_imugps(_alloc)
    , angular_velocity_imugps_covariance()
    , linear_acceleration_imugps(_alloc)
    , linear_acceleration_imugps_covariance()
    , roll_pitch_yaw_imugps(_alloc)
    , roll_pitch_yaw_imugps_covariance()
    , linear_velocity_imugps(_alloc)
    , linear_velocity_imugps_covariance()
    , v_x_imugps(0.0)
    , v_x_imugps_covariance(0.0)
    , altitude(0.0)
    , longitude(0.0)
    , latitude(0.0)
    , position_covariance()  {
  (void)_alloc;
      orientation_covariance.assign(0.0);

      angular_velocity_imugps_covariance.assign(0.0);

      linear_acceleration_imugps_covariance.assign(0.0);

      roll_pitch_yaw_imugps_covariance.assign(0.0);

      linear_velocity_imugps_covariance.assign(0.0);

      position_covariance.assign(0.0);
  }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef ros::Time _can_ts_type;
  _can_ts_type can_ts;

   typedef ros::Time _gps_ts_type;
  _gps_ts_type gps_ts;

   typedef ros::Time _imu_ts_type;
  _imu_ts_type imu_ts;

   typedef double _v_x_CAN_type;
  _v_x_CAN_type v_x_CAN;

   typedef double _v_x_CAN_covariance_type;
  _v_x_CAN_covariance_type v_x_CAN_covariance;

   typedef double _yawrate_type;
  _yawrate_type yawrate;

   typedef double _yawrate_covariance_type;
  _yawrate_covariance_type yawrate_covariance;

   typedef double _acceleration_x_type;
  _acceleration_x_type acceleration_x;

   typedef double _acceleration_x_covariance_type;
  _acceleration_x_covariance_type acceleration_x_covariance;

   typedef double _acceleration_y_type;
  _acceleration_y_type acceleration_y;

   typedef double _acceleration_y_covariance_type;
  _acceleration_y_covariance_type acceleration_y_covariance;

   typedef  ::geometry_msgs::Quaternion_<ContainerAllocator>  _orientation_type;
  _orientation_type orientation;

   typedef boost::array<double, 9>  _orientation_covariance_type;
  _orientation_covariance_type orientation_covariance;

   typedef  ::geometry_msgs::Vector3_<ContainerAllocator>  _angular_velocity_imugps_type;
  _angular_velocity_imugps_type angular_velocity_imugps;

   typedef boost::array<double, 9>  _angular_velocity_imugps_covariance_type;
  _angular_velocity_imugps_covariance_type angular_velocity_imugps_covariance;

   typedef  ::geometry_msgs::Vector3_<ContainerAllocator>  _linear_acceleration_imugps_type;
  _linear_acceleration_imugps_type linear_acceleration_imugps;

   typedef boost::array<double, 9>  _linear_acceleration_imugps_covariance_type;
  _linear_acceleration_imugps_covariance_type linear_acceleration_imugps_covariance;

   typedef  ::geometry_msgs::Vector3_<ContainerAllocator>  _roll_pitch_yaw_imugps_type;
  _roll_pitch_yaw_imugps_type roll_pitch_yaw_imugps;

   typedef boost::array<double, 9>  _roll_pitch_yaw_imugps_covariance_type;
  _roll_pitch_yaw_imugps_covariance_type roll_pitch_yaw_imugps_covariance;

   typedef  ::geometry_msgs::Vector3_<ContainerAllocator>  _linear_velocity_imugps_type;
  _linear_velocity_imugps_type linear_velocity_imugps;

   typedef boost::array<double, 9>  _linear_velocity_imugps_covariance_type;
  _linear_velocity_imugps_covariance_type linear_velocity_imugps_covariance;

   typedef double _v_x_imugps_type;
  _v_x_imugps_type v_x_imugps;

   typedef double _v_x_imugps_covariance_type;
  _v_x_imugps_covariance_type v_x_imugps_covariance;

   typedef double _altitude_type;
  _altitude_type altitude;

   typedef double _longitude_type;
  _longitude_type longitude;

   typedef double _latitude_type;
  _latitude_type latitude;

   typedef boost::array<double, 9>  _position_covariance_type;
  _position_covariance_type position_covariance;





  typedef boost::shared_ptr< ::ld_msgs::ld_imugps_can_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ld_msgs::ld_imugps_can_<ContainerAllocator> const> ConstPtr;

}; // struct ld_imugps_can_

typedef ::ld_msgs::ld_imugps_can_<std::allocator<void> > ld_imugps_can;

typedef boost::shared_ptr< ::ld_msgs::ld_imugps_can > ld_imugps_canPtr;
typedef boost::shared_ptr< ::ld_msgs::ld_imugps_can const> ld_imugps_canConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ld_msgs::ld_imugps_can_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ld_msgs::ld_imugps_can_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ld_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/kinetic/share/sensor_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/kinetic/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/kinetic/share/geometry_msgs/cmake/../msg'], 'ld_msgs': ['/home/xiaotongliu/CANMessageParser/src/ld_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_imugps_can_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_imugps_can_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_imugps_can_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_imugps_can_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_imugps_can_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_imugps_can_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ld_msgs::ld_imugps_can_<ContainerAllocator> >
{
  static const char* value()
  {
    return "c5fa84ba8cca77f2af30305dec211727";
  }

  static const char* value(const ::ld_msgs::ld_imugps_can_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xc5fa84ba8cca77f2ULL;
  static const uint64_t static_value2 = 0xaf30305dec211727ULL;
};

template<class ContainerAllocator>
struct DataType< ::ld_msgs::ld_imugps_can_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ld_msgs/ld_imugps_can";
  }

  static const char* value(const ::ld_msgs::ld_imugps_can_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ld_msgs::ld_imugps_can_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n\
\n\
time can_ts\n\
time gps_ts\n\
time imu_ts\n\
\n\
# velocity from CAN message [m/s]\n\
float64 v_x_CAN\n\
float64 v_x_CAN_covariance\n\
\n\
# yawrate from CAN message [rad/s]\n\
float64 yawrate\n\
float64 yawrate_covariance\n\
\n\
# x accelerate from CAN message [m/s^2]\n\
float64 acceleration_x\n\
float64 acceleration_x_covariance\n\
\n\
# y accelerate from CAN message [m/s^2]\n\
float64 acceleration_y\n\
float64 acceleration_y_covariance\n\
\n\
# orientation information from imugps\n\
geometry_msgs/Quaternion orientation\n\
float64[9] orientation_covariance # Row major about x, y, z axes\n\
\n\
# angular velocity from imugps [rad/s]\n\
geometry_msgs/Vector3 angular_velocity_imugps\n\
float64[9] angular_velocity_imugps_covariance # Row major about x, y, z axes\n\
\n\
# linear acceleration from imugps Longitudinal(x) cross(y) vertical(z) [m/s^2]\n\
geometry_msgs/Vector3 linear_acceleration_imugps\n\
float64[9] linear_acceleration_imugps_covariance # Row major x, y z \n\
\n\
# roll pitch yaw from imugps [rad]\n\
geometry_msgs/Vector3 roll_pitch_yaw_imugps\n\
float64[9] roll_pitch_yaw_imugps_covariance\n\
\n\
# linear_velocity from imugps N(x)W(y)U(z) [m/s]\n\
geometry_msgs/Vector3 linear_velocity_imugps\n\
float64[9] linear_velocity_imugps_covariance\n\
\n\
# linear_velocity from imugps V_x [m/s]\n\
float64 v_x_imugps\n\
float64 v_x_imugps_covariance\n\
\n\
# position information from GPS altitude longitude latitude [rad]\n\
float64 altitude\n\
float64 longitude\n\
float64 latitude\n\
float64[9] position_covariance\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n\
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
# It is only meant to represent a direction. Therefore, it does not\n\
# make sense to apply a translation to it (e.g., when applying a \n\
# generic rigid transformation to a Vector3, tf2 will only apply the\n\
# rotation). If you want your data to be translatable too, use the\n\
# geometry_msgs/Point message instead.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
";
  }

  static const char* value(const ::ld_msgs::ld_imugps_can_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ld_msgs::ld_imugps_can_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.can_ts);
      stream.next(m.gps_ts);
      stream.next(m.imu_ts);
      stream.next(m.v_x_CAN);
      stream.next(m.v_x_CAN_covariance);
      stream.next(m.yawrate);
      stream.next(m.yawrate_covariance);
      stream.next(m.acceleration_x);
      stream.next(m.acceleration_x_covariance);
      stream.next(m.acceleration_y);
      stream.next(m.acceleration_y_covariance);
      stream.next(m.orientation);
      stream.next(m.orientation_covariance);
      stream.next(m.angular_velocity_imugps);
      stream.next(m.angular_velocity_imugps_covariance);
      stream.next(m.linear_acceleration_imugps);
      stream.next(m.linear_acceleration_imugps_covariance);
      stream.next(m.roll_pitch_yaw_imugps);
      stream.next(m.roll_pitch_yaw_imugps_covariance);
      stream.next(m.linear_velocity_imugps);
      stream.next(m.linear_velocity_imugps_covariance);
      stream.next(m.v_x_imugps);
      stream.next(m.v_x_imugps_covariance);
      stream.next(m.altitude);
      stream.next(m.longitude);
      stream.next(m.latitude);
      stream.next(m.position_covariance);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct ld_imugps_can_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ld_msgs::ld_imugps_can_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ld_msgs::ld_imugps_can_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "can_ts: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.can_ts);
    s << indent << "gps_ts: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.gps_ts);
    s << indent << "imu_ts: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.imu_ts);
    s << indent << "v_x_CAN: ";
    Printer<double>::stream(s, indent + "  ", v.v_x_CAN);
    s << indent << "v_x_CAN_covariance: ";
    Printer<double>::stream(s, indent + "  ", v.v_x_CAN_covariance);
    s << indent << "yawrate: ";
    Printer<double>::stream(s, indent + "  ", v.yawrate);
    s << indent << "yawrate_covariance: ";
    Printer<double>::stream(s, indent + "  ", v.yawrate_covariance);
    s << indent << "acceleration_x: ";
    Printer<double>::stream(s, indent + "  ", v.acceleration_x);
    s << indent << "acceleration_x_covariance: ";
    Printer<double>::stream(s, indent + "  ", v.acceleration_x_covariance);
    s << indent << "acceleration_y: ";
    Printer<double>::stream(s, indent + "  ", v.acceleration_y);
    s << indent << "acceleration_y_covariance: ";
    Printer<double>::stream(s, indent + "  ", v.acceleration_y_covariance);
    s << indent << "orientation: ";
    s << std::endl;
    Printer< ::geometry_msgs::Quaternion_<ContainerAllocator> >::stream(s, indent + "  ", v.orientation);
    s << indent << "orientation_covariance[]" << std::endl;
    for (size_t i = 0; i < v.orientation_covariance.size(); ++i)
    {
      s << indent << "  orientation_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.orientation_covariance[i]);
    }
    s << indent << "angular_velocity_imugps: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "  ", v.angular_velocity_imugps);
    s << indent << "angular_velocity_imugps_covariance[]" << std::endl;
    for (size_t i = 0; i < v.angular_velocity_imugps_covariance.size(); ++i)
    {
      s << indent << "  angular_velocity_imugps_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.angular_velocity_imugps_covariance[i]);
    }
    s << indent << "linear_acceleration_imugps: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "  ", v.linear_acceleration_imugps);
    s << indent << "linear_acceleration_imugps_covariance[]" << std::endl;
    for (size_t i = 0; i < v.linear_acceleration_imugps_covariance.size(); ++i)
    {
      s << indent << "  linear_acceleration_imugps_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.linear_acceleration_imugps_covariance[i]);
    }
    s << indent << "roll_pitch_yaw_imugps: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "  ", v.roll_pitch_yaw_imugps);
    s << indent << "roll_pitch_yaw_imugps_covariance[]" << std::endl;
    for (size_t i = 0; i < v.roll_pitch_yaw_imugps_covariance.size(); ++i)
    {
      s << indent << "  roll_pitch_yaw_imugps_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.roll_pitch_yaw_imugps_covariance[i]);
    }
    s << indent << "linear_velocity_imugps: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "  ", v.linear_velocity_imugps);
    s << indent << "linear_velocity_imugps_covariance[]" << std::endl;
    for (size_t i = 0; i < v.linear_velocity_imugps_covariance.size(); ++i)
    {
      s << indent << "  linear_velocity_imugps_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.linear_velocity_imugps_covariance[i]);
    }
    s << indent << "v_x_imugps: ";
    Printer<double>::stream(s, indent + "  ", v.v_x_imugps);
    s << indent << "v_x_imugps_covariance: ";
    Printer<double>::stream(s, indent + "  ", v.v_x_imugps_covariance);
    s << indent << "altitude: ";
    Printer<double>::stream(s, indent + "  ", v.altitude);
    s << indent << "longitude: ";
    Printer<double>::stream(s, indent + "  ", v.longitude);
    s << indent << "latitude: ";
    Printer<double>::stream(s, indent + "  ", v.latitude);
    s << indent << "position_covariance[]" << std::endl;
    for (size_t i = 0; i < v.position_covariance.size(); ++i)
    {
      s << indent << "  position_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.position_covariance[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // LD_MSGS_MESSAGE_LD_IMUGPS_CAN_H
